﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Public Class Person
    Implements INotifyPropertyChanged
    Public Sub New()
    End Sub
    Public Sub New(firstname As String, lastname As String, Optional gender As PersonGender = PersonGender.Male)
        Me.FirstName = firstname
        Me.LastName = lastname
        Me.Gender = gender
    End Sub

    Private _firstName As String
    Public Property FirstName() As String
        Get
            Return _firstName
        End Get
        Set(ByVal value As String)
            _firstName = value
            RaisePropertyChanged()
            RaisePropertyChanged(NameOf(FullName))
        End Set
    End Property

    Private _lastName As String

    Public Property LastName() As String
        Get
            Return _lastName
        End Get
        Set(ByVal value As String)
            _lastName = value
            RaisePropertyChanged()
            RaisePropertyChanged(NameOf(FullName))
        End Set
    End Property

    Public ReadOnly Property FullName As String
        Get
            Return $"{FirstName} {LastName}"
        End Get
    End Property

    Private _gender As PersonGender = PersonGender.Male

    Public Property Gender() As PersonGender
        Get
            Return _gender
        End Get
        Set(ByVal value As PersonGender)
            _gender = value
            RaisePropertyChanged()
        End Set
    End Property


    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
End Class

Public Enum PersonGender
    Male = 0
    Female = 1
End Enum
